<template>
  <div class="row mt-3">
    <div class="col-10"></div>
    <div class="col-2 text-end px-2">
      <button type="button" class="btn btn-secondary mx-1 mt-4 p-1 px-2 mb-4" @click="goToFormularioEditar()">
        <i class="bi bi-plus-square mx-1 fonts-sm p-0"></i> NUEVO
      </button>
    </div>
  </div>
  <table class="table  table-striped" v-if="cuposStore.listadoCargosCabecera.length > 0">
    <thead>
      <tr>
        <th scope="col">Fecha</th>
        <th scope="col">Cargo</th>
        <th scope="col">Fecha Desde</th>
        <th scope="col">Fecha Hasta</th>
        <th scope="col">Monto Anual</th>
        <th scope="col">Observaciones</th>
        <th scope="col">Acciones</th>
      </tr>
    </thead>
    <tbody>
      <tr v-for="cupos in cuposStore.listadoCargosCabecera" :key="cupos.id_cupo_movimiento_cabecera">
        <td v-text="formatDate(cupos.f_transf)"></td>
        <td v-text="cupos.d_cargo"></td>
        <td v-text="formatDate(cupos.f_desde)"></td>
        <td v-text="formatDate(cupos.f_hasta)"></td>
        <td v-text="'$'+formatPrice(cupos.importe)"></td>
        <td v-text="cupos.observ"></td>
        <td>
<!--           <router-link alt="Editar Cupo" title="Editar Cupo" :to="{
            name: 'editar-cupos',
            params: { id: cupos.id_cupo_movimiento_cabecera },
          }">
            <button class="btn btn-principal btn-sm pt-0 pb-0 px-1 mb-2 mt-0 mx-1" alt="Editar" title="Editar">
              <i class="bi bi-pencil-square text-light"></i>

            </button>
          </router-link> -->
          <button  class="btn btn-borrar-table  mx-2 text-uppercase p-0 px-2 fs-5" alt="Borrar" title="Borrar"
            @click="borrar(cupos.id_cupo_movimiento_cabecera)">
            <i class="fa-solid fa-trash-can"></i>
          </button>
        </td>
      </tr>
    </tbody>
  </table>
  <div v-else class="alert alert-secondary" role="alert">
    No hay elementos para mostrar
  </div>
</template>
  
<script setup lang="ts">

//librerias
import { useRoute, useRouter } from "vue-router";
import { loading, urlApi } from "@/shared.js";
import http from "@/http";
import Swal from "sweetalert2/dist/sweetalert2.js";
import type { SweetAlertOptions, SweetAlertResult } from "sweetalert2";
//import { AxiosError } from "axios";
import type { AxiosResponse, AxiosError } from "axios";
import { DateTime } from "luxon";
//store
import { useCuposStore } from "@/stores/Cupos/cupos";
import { useConfigStore } from "@/stores/configgral";


const route = useRoute();
const router = useRouter();
const cuposStore = useCuposStore();
const configStore = useConfigStore()

function formatDate(date: string | null) {
  if (date != null) {
    // return moment(date).format("DD/MM/YYYY");
    return DateTime.fromISO(date).toLocaleString();
  }
}


function formatPrice(value : any) {
        let val = (value/1).toFixed(2).replace('.', ',')
        return val.toString().replace(/\B(?=(\d{3})+(?!\d))/g, ".")
    }


function goToFormularioEditar() {
  router.push({
    name: "editar-cupos",
  });
}


function borrar(id_cupo_movimiento_cabecera: Number) {

  const swal_error: SweetAlertOptions<any, any> = {
    icon: "error",
    title: "Error",
    html: "",
  }

  Swal.fire({
    icon: "question",
    title: "Confirmaci&oacute;n",
    html: "¿Confirma la eliminaci&oacute;n del Cupo? Esta acci&oacute;n no podr&aacute; ser revertida.",
    showCancelButton: true,
    confirmButtonColor: "#3085d6",
    cancelButtonColor: "#d33",
    confirmButtonText: "Confirmar",
    cancelButtonText: "Cancelar",
  }).then(async (result) => {
    if (result.isConfirmed) {
      loading.show();
      var rta = await http.post(urlApi + "deleteCupoSolicitanteGrabar", {
        tipo_transf:'C',//tipo transf falta
        id_cupo_movimiento_cabecera: id_cupo_movimiento_cabecera,
      }).then(async () => {
        var anio = configStore.listadoPeriodoActivo[0]?.anioActivo;
        console.log(anio);
        await cuposStore.updateListadoCargosCabecera({
          id_cargo: null,
          id_tabla_sol: null,
          tipo_transf: "C",
          f_transf_desde: anio + "-03-01",
          f_transf_hasta: anio + "-12-31",
        });
        Swal.fire({
          icon: "success",
          text: "Se Borro el Cupo.",
        })
        loading.hide();
      }).catch(function (error: AxiosError<string, any>) {
        if (error.response) {
          // Request made and server responded
          swal_error.html =
            error.message +
            " (" +
            error.code +
            ")." +
            "<br />" +
            error.response.data.substring(
              error.response.data.indexOf("<h2>") + 4,
              error.response.data.indexOf("</h2>")
            );
          console.log("Error: request made and server responded");
          console.log(swal_error.html);
          console.log(error.response);
        } else if (error.request) {
          // The request was made but no response was received
          swal_error.html =
            "Error desconocido. Por favor, avise al Administrador.";
          console.log("Error: the request was made but no response was received");
          console.log(error.request);
        } else {
          // Something happened in setting up the request that triggered an Error
          swal_error.html =
            "Error desconocido. Por favor, avise al Administrador.";
          console.log(
            "Error: something happened in setting up the request that triggered an error"
          );
          console.log(error);
        }
        loading.hide();
        Swal.fire(swal_error);
      });
    }
  });
}

</script>
  